#ifndef __NFloat_h__
#define __NFloat_h__
// **************************************************************************
//                     @N oCg_Z
// --------------------------------------------------------------------------
//   @4 oCgȉ̂ƂAxʂɔzƎw 7 rbgxÓȂ̂ŁA
//   {vO̓KṕA N  8 oCgȏƂ邱Ƃ]܂B
// **************************************************************************    
//  _(NFloat)́A擪 2 oCg𕄍16̎w\AcƂB
//
//  i[̓gGfBABȂ킿AԒnႢʂƂ݂ȂB
//
//           1 bit                                       
//     @@@    w 15 bits(16^nƂ2̕␔) ( N-2 bytes)
//     @@@+-+-----+-------+-------+-------+-------+-------+-------+-------+ 
//@@@@@ | |   w@@|            ( N-2 bytes)                 |     
// @@@    +-+-----+-------+-------+-------+-------+-------+-------+-------+     
// oCgʒuF N-1   N-2    @N-3      c@     3       2       1       0
//-----------------------------------------------------------------------------------^
//  Px(SFloat)́A擪 1 oCg𕄍16̎w\Ac 3 oCgƂB
//  PxZ NFloat Zőp̂ƂAϊ֐݂̂pӂB
//
//  i[̓gGfBABȂ킿AԒnႢʂƂ݂ȂB
//
//           1 bit                                       
//     @@@b  w 7 bits(16^nƂ2̕␔) ( N-2 bytes)
//               
//     @@@+-+-----+-------+-------+-------+ 
//@@@@@ | |   @|    (3bytes)     |     
// @@@    +-+-----+-------+-------+-------+     
// oCgʒuF  3       2       1       0
//
// lZ
//   void NFadd(NFloat X, NFloat A, NFloat B)	X  = A + B
//   void NFsub(NFloat X, NFloat A, NFloat B)	X  = A - B
//   void NFmlt(NFloat X, NFloat A, NFloat B)	X  = A * B
//   void NFdiv(NFloat X, NFloat A, NFloat B)	X  = A / B
//   void NFadd(NFloat X, NFloat B)				X += B
//   void NFsub(NFloat X, NFloat B)				X -= B
//   void NFmlt(NFloat X, NFloat B)				X *= B
//   void NFdiv(NFloat X, NFloat B)				X /= B
//   void NFminus(NFloat X)						X  = -X
//   void NFminus(NFloat A, NFloat B)			A  = -B
//
// 召r
//   int NFcmp   (NFloat A, NFloat B)	A>B ̂Ƃ1, A>B ̂Ƃ0, A<B ̂Ƃ-1B
//   int NAeq0     (NFloat A)			A ̉ 0 ̂Ƃ 1, ȊO 0 ԋpB
//   int NAcmp(NFloat A, NFloat B)		Βl̑傫̔rBԋpl NFcmp ƓB
//
// Zp֐
//   void NFabs	   (NFloat X)					  X ̐Βl X ɕԋpB
//   void NFabs	   (NFloat A, NFloat B)			  B ̐Βl A ɕԋpB
//   void Acos	   (NFloat Z, NFloat X)			  Arccos(X)  Z ɕԋpB
//   void Asin	   (NFloat Z, NFloat X)			  Arcsin(X)  Z ɕԋpB
//   void Atan	   (NFloat Z, NFloat X)			  Arctan(X)  Z ɕԋpB
//   void cmpPai   (NFloat PI)					  ΂̒l PI ɐݒB
//   void cmpNapier(NFloat E)					  lCsA(Rΐ̒) E ɐݒB
//   void cos	   (NFloat CosA, NFloat Angle)	  cos(Angle)  CosA ɕԋpB
//   void cosh	   (NFloat CoshA, NFloat A)	      cosh(A)  CoshA ɕԋpB
//   void exp	   (NFloat A, NFloat X)			  exp(X)  A ɕԋpB
//   void NFfix	   (NFloat A)					  A ̏JbgicjB
//   **** gamma2017/08/05_Ō덷傫܂Bւexp(logGamma(X))gĂB
//   void gamma    (NFloat R, NFloat AX)		  K}֐(X)vZ R ɕԋpB
//   void log	   (NFloat A, NFloat X)			  log(X)  A ɕԋpB
//   void log2	   (NFloat ln2)					  log(2)  ln2 ɐݒB
//   void logGamma (NFloat R, NFloat AX)		  log((X))vZ R ɕԋpB
//   void pow	   (NFloat Z, NFloat X, NFloat N) X  N ׂ Z ɕԋpB
//   void sin	   (NFloat SinA, NFloat Angle)	  sin(Angle)  SinA ɕԋpB
//   void sinh	   (NFloat SinhA, NFloat A)	      sinh(A)  SinhA ɕԋpB
//   void sqrt	   (NFloat A, NFloat X)			  X ̕ A ɕԋpB
//   void tan	   (NFloat TanA, NFloat Angle)	  tan(Angle)  TanA ɕԋpB
//   void tanh	   (NFloat TanhA, NFloat A)	      tanh(A)  TanhA ɕԋpB
//   (Op֐AΐAwÅׂ֐ďoOɗ\void startNFloat()Ăяo)
//
// ^ϊElݒ蓙
//   void   NAclrFlagAndExp(NFloat X)		  wƕtO 0 ݒB
//   void   NFclear    (NFloat X)			  X 0 ݒB
//   void   NFcopy     (NFloat A, NFloat B)	  BAɕʁB
//   int    NFgetExp   (NFloat A)			  woB
//   int    NFgetFlag  (NFloat A)			  oB
//   void   NFhexaTo(NFloat X,char str[][5],int N)
//                                            NFintToDT16iŕ\L@B
//   void   NFintMax   (NFloat X)			  ől NFloat l X ɐݒB
//   void   NFintMin   (NFloat X)			  ̐Βlő NFloat l X ɐݒB
//   void   NFintTo    (NFloat A, int B)	   B  NFloat ɕϊ A ɕԋpB
//   void   NFintTo(NFloat X,int DT[],int N)  zNFloatɒڑB
//                                            Cʌ2oCgPʂŎw肷
//                                            z擪͕rbgƎwBʂ牺ʂցB
//                                            NŔzTCY̐w肷B
//                                            ʏ́CNFLOATLENN
//   void   NFmachineE (NFloat X)             @B(Machine )vZB
//   void   NFmmax     (NFloat A)			  ̐Βlő̒l A ɕԋpB
//   void   NFpmax     (NFloat A)			  ől A ɕԋpB
//   void   NFmmax     (NFloat A)			  ̐Βlő̒l A ɕԋpB
//   void   NFpowMini  (NFloat P, NFloat X,   ^N ̒l P ɐݒBexp ֐ E^n vZpB
//                      int N)	              exp ֐ E^n vZpB
//	 void   NFrevMini@(NFloat X, int N)	  X  1/N ̒lݒ(1X16)B
//   void   NFsetFlagExp(NFloat A,int Flag,   A ɕ Flag Ǝw Exp ݒB
//					@@ int Exp) 
//	 void	NFSFloat(NFloat X, SFloat A)	  Px SFloat A  NFloatɕϊ X ɕԋp
//   void	NFstring(NFloat nF, char str[])	   str  NFloat ɕϊ nF ɕԋpB
//   SFloat NFstring(char str[])			   str  SFloat ɕϊĖ߂lƂĕԋpB
//   int@  NFtoAbsInt (NFloat X)			  NFloat Βl𐮐ɕϊB
//	 int    NFtoExpStr (NFloat DT,			  DT _ȉ Np  E} `Ƃ
//		    char ch[], int Np, int SpIns)	  ch ɕԋpB_ȉ5Pʂŋ؂ꍇ
//											  SpIns  1, ؂Ȃꍇ 0 wB
//   int    NFtoExpStr (SFloat A,			@PxDT _ȉ Np  E} `
//			char ch[], int Np, int SpIns)	  ƂĕԂB NFloat ̏ꍇƓB
//   int	NFtoExpStr (SFloat A, char ch[])  _ȉ 5C_ȉ󔒂ŋ؂ȂB
//   int    NFtoInt@@(NFloat X)			  NFloat 𐮐ɕϊi܂ށjB
//   SFloat NFtoSFloat (NFloat X)			  NFloat Px SFloat ɕϊ
//   int    NFtoString(NFloat DT, char ch[],  DT _ȉ Np  99.99 `Ƃ
//			int Np, int cmIns)				  ch ɕԋpBJ}ŋ؂ꍇAcmIns=1
//   int    NFtoString(SFloat A, char ch[],   PxpϊB
//			int Np, int CmIns)
//   int    NFtoString(SFloat A, char ch[])	@PxpϊBJ}؂ȂB_ȉ
//											   5
// \֐iNFtoExpStr͌^ϊŐj
//   void NFprint(char preMsg[], NFloat X, int Np)  NFloat\(preMsgɐs镶,
//   void NFprint(char preMsg[], NFloat X)			Npɏ_ȉw,ȗ5j
//   void NFprintF(char preMsg[], NFloat X, int Np, NFloat\BJ}ŋ؂Ƃ
//			int CmIns)@							CmIns ɂPw肷B
//   void NFprintF(char preMsg[], NFloat X)			NFloat\B5AJ}͕\ȂB   void NFprintHx(NFloat X)						X16iŕ\B
//   void NFprintHx(char preMsg[], NFloat X)		X16iŕ\(\st)B
//
// {(I[o[t[̂Ƃ 1, ̂Ƃ 0 ԋpBA_[t[ 0 Ƃ݂Ȃ)
//   int NAadd(NFloat R, NFloat X, NFloat Y)	ΒlZilȂjR = X + Y
//   int NAsub(NFloat R, NFloat X, NFloat Y)	ΒlZilȂjR = X - Y
//   int NAmlt(NFloat R, NFloat X, NFloat Y)	ΒlZilȂjR = X * Y
//   int NAmlt(NFloat R, NFloat X, NFloat Y,	  MsgFlag :I[o[t[̃bZ[Wo
//						 		 int MsgFlag)	  @@0 : o͂Ȃ, 1 : o͂Ȃ
//   int NAdiv(NFloat R, NFloat X, NFloat Y)	ΒlZilȂjR = X / Y
//  												( 0 fBoCĥƂ֐l 2 ԋp)
// Pxp NFloat ֐Ăяo
//
//  (1) ܂Aȉ̂悤Ȑ錾sB
//		void (*NFfun2v)(NFloat x,NFloat y,NFloat z);
//		void (*NFfun1v)(NFloat x,NFloat y);
//		int  (*NFfun2i)(NFloat x,NFloat y,NFloat z);
//		int  (*NFfun1i)(NFloat x,NFloat y);
//
//	(2) L(1)Ő錾ϐɊ֐AhXݒ肵āÂ悤ɌĂяoB
//		NFfun2v=֐  ; R = NFcallSF(NFfun2v, SFloat A, SFloat B);
//		NFfun1v=֐  ; R = NFcallSF(NFfun1v, SFloat A, SFloat B);
//		NFfun2i=֐  ; R = NFcallSF(NFfun2i, SFloat A, SFloat B);
//		NFfun1i=֐  ; R = NFcallSF(NFfun1i, SFloat A, SFloat B);
//
//  (3) Ăяo
//		SFloat A, B, R;
//			:
//			:
//		void (*NFfun2)(NFloat x,NFloat y,NFloat z);
//		void (*NFfun1)(NFloat x,NFloat y);
//			:
//			:  (A, Bɒlݒ)
//			:
//		NFfun2=NFadd  ; R = NFcallSF(NFfun2, A, B); 
//		NFfun2=NFsub  ; R = NFcallSF(NFfun2, A, B); 
//		NFfun1=NFminus; R = NFcallSF(NFfun1, A   ); 
//		NFfun1=sin    ; R = NFcallSF(NFfun1, A   ); 
//
#include "stdio.h"
#include "stdarg.h"
#include "stdlib.h"
#include "string.h"
#define NFLOATLEN 16				// _̒
#define NFDIVLOOP NFLOATLEN*2-4		// Z[v(̃oCg*2)
#define NMULTTEMP (NFLOATLEN-2)*2+1	// ZpƗ̈̃TCY
union charINT{     // wݒEo܂͏Zŏʕ]̐ݒp̋p
	unsigned char CHAR[2]; short int     SINT;
};
union singleDT{//SFloat(Px_jpp
	unsigned long INT; unsigned char CH[4];
};
typedef struct{ //SFloat(Px_j
	union singleDT DT;
}SFloat;
typedef unsigned char NFloat[NFLOATLEN];   // _^Cv
typedef unsigned char multTemp[NMULTTEMP]; // ZvZpƗ̈̃^Cv
NFloat PAI        ; //	΂̒l
NFloat NAPIER     ;	//	lCsA(Rΐ̒ e)
NFloat LOG2       ;	//	log 2̒liRΐ)
NFloat MACHINE_EPS; //	@B(Mashine )
//------ (ʏ) ----------------------------------------------------------------
void NFprintHx(NFloat X){									// 16i\Lɂ\
	for(int i=NFLOATLEN-1;i>=0;i--){printf("%02X",X[i]);if((i %2) == 0)printf(" ");}
}
void NFprintHx(char preMsg[], NFloat X){	// 16i\Lɂ\(s\)
	printf(preMsg); NFprintHx(X);
}
void NFcopy(NFloat A, NFloat B){for(int i=0;i<NFLOATLEN;i++) A[i]=B[i];}// 
void NFclear    (NFloat X){	for(int i=0;i<NFLOATLEN;i++) X[i]=0;}		// [ݒ
void NAclrFlagAndExp(NFloat X){ X[NFLOATLEN-2]=0; X[NFLOATLEN-1]=0 ;}	// w[

int NFgetExp(NFloat X){										// wo
	charINT D; D.CHAR[0] = X[NFLOATLEN-2];D.CHAR[1] = X[NFLOATLEN-1];
	D.SINT&=0x7FFF;if((D.SINT & 0x4000)!=0) D.SINT |= 0x8000;
	return (int) D.SINT;
}
int NFgetFlag(NFloat X){ return (((X[NFLOATLEN-1])&0x80)!=0);}// o
void NFsetFlagExp(NFloat X, int Flag, int EXP){			// Ǝwݒ
	charINT D; D.SINT=(short int)(EXP & 0x7FFF); if(Flag) D.SINT |= 0x8000;
	X[NFLOATLEN-2]=D.CHAR[0];X[NFLOATLEN-1]=D.CHAR[1];
}
void NFsetFlag(NFloat X, int Flag){						// ݒ
	if(Flag) X[NFLOATLEN-1] |= 0x80; else X[NFLOATLEN-1] &= 0x7F;
}
void NFminus(NFloat X) {X[NFLOATLEN-1] ^= 0x80;}		// t]
void NFminus(NFloat A, NFloat B) {						// t](A = -B)
	NFcopy(A, B); NFminus(A);
}		
void NFlowShift4(NFloat X,int MX){						// 4rbgʕɃVtg
	unsigned int U=0, B;for(int i=MX ; i>=0;i--){ B=X[i]<<4; X[i]=(X[i]>>4) | U; U=B; }
}
void NFlowShift(NFloat X, int Nshift){					// 4*NshiftʕɃVtg
	if(Nshift<=0)return;						//Vtgʂ 0 ȉ̂Ƃ
	int N=Nshift/2, Nbit=Nshift-N*2;int i=0;
	if(N>0){									// *4rbgVtg1oCgړ
		int MX=NFLOATLEN-2;	while(i<MX){ if((i-N)>=0)X[i-N]=X[i]; i++;}
		i-=N; if(i<0)i=0  ; while(i<NFLOATLEN-2){X[i]=0;i++;}	//ʂ0Zbg
	}
	if(Nbit!=0) NFlowShift4(X,NFLOATLEN-3);		//4rbgVtg
}
void NFupShift4(NFloat X, int MX){						// ʕ4rbgVtg
	unsigned int U=0,B;	for(int i=0; i<=MX;i++){ B=X[i]>>4; X[i]=X[i]<<4 | U; U=B;}
}
void NFupShift(NFloat X, int Nshift){					// 4*NshiftʕɃVtg
	if(Nshift<=0)return;						//Vtgʂ 0 ȉ̂Ƃ
	int N=Nshift/2, Nbit=Nshift-N*2;int i=NFLOATLEN-3;
	if(N>0){									// *4rbgVtg1oCgړ
		int MX=NFLOATLEN-2;	while(i>=0){ if((i+N)<MX) X[i+N]=X[i]; i--;}
		i=i+N; while(i>=0){X[i]=0;i--;}			// ʂ0Zbg
	}
	if(Nbit!=0) NFupShift4(X, NFLOATLEN-3);		// 4rbgVtg
}
int NFgetNomalizeShiftLen(NFloat X){					// K̂߂̃Vtg
	int N=0;
	for(int i=NFLOATLEN-3; i>=0; i--, N += 2 ){
		if(X[i] >=16) return N; else if(X[i]!=0) return N+1;
	}
	return -1;									// ׂ0̂Ƃԋp
}
void NFnomal(NFloat X){								// K
	int N=NFgetNomalizeShiftLen(X); if(N==0) return;// Vtg 0 ̂ƂȂ
	if(N<0){NFsetFlagExp(X,0,0); return;}			// ׂ0̂Ƃ
	int Flag=NFgetFlag(X), Exp=NFgetExp(X);
	NFupShift(X,N);	NFsetFlagExp(X, Flag, Exp-N);	// Vtgʕw獷
}
void NFintMin(NFloat X){							// ̐Βlő
	int i=NFLOATLEN-1; X[i--]=0x80; X[i--]=0x08; X[i--]=0x80;
	while(i >= 0) X[i--]=0;
}
void NFintTo(NFloat X, int Num){					// NFloatɕϊ
	if(Num==0x80000000){NFintMin(X);return;}
	NFclear(X);if(Num==0) return;								// NA
	int N=Num, Flag=false;if(Num<0){ N=-Num; Flag=true;}		// ΒlɂB
	int keta=0;NFloat R; while(N!=0){R[keta++]=N % 256; N>>=8;}	// 256Pʂňړ
	int i,j; for(i=keta-1, j = NFLOATLEN-3; i>=0 && j>=0; i--, j--)X[j]=R[i];
	if(i>0) keta+=i; NFsetFlagExp(X,Flag, keta*2); NFnomal(X);	// wݒƐK
}
int NAeq0(NFloat A){									// 0̔
	for(int i=NFLOATLEN-3;i>=0;i--) if(A[i]!=0)return false; return true;
}
int NAcmp(NFloat A, NFloat B){							// Βlr
	NFnomal(A); NFnomal(B); int A0=NAeq0(A), B0=NAeq0(B);
	if(A0 && B0)return  0;if(A0)return -1; if(B0)return  1;	//ǂ炩0̂Ƃ
	A0=NFgetExp(A); B0=NFgetExp(B);	
	if(A0>B0) return 1; if(A0<B0)return -1;	//wr
	for(int i=NFLOATLEN-3;i>=0;i--) {		//wƂŔr
		if(A[i]>B[i]) return 1; else if(A[i]<B[i]) return -1;
	}
	return 0;
}
void NFsetFrac(NFloat X, int exp, unsigned char N0, int N, ...){//  16izݒ
	unsigned char NN[16]; // N0擪, N͏z̐(ʂ0̂Ƃ0zƂ݂Ȃ)
	va_list ap; va_start(ap,N); int j=15;// N̈oAi[
	for(int i=0;i<N;i++) NN[j--]=va_arg(ap,unsigned char);	//unsigned char
	va_end(ap);												//I
	if(j>=0) for(int i=0;i<N;i++) NN[i]=NN[++j];			//i[Ol
	union charINT DT;DT.SINT=exp;							//擪ݒ
	X[NFLOATLEN-1]=DT.CHAR[1]; X[NFLOATLEN-2]=DT.CHAR[0]; X[NFLOATLEN-3]=N0;j=N-1;
	for(int i=NFLOATLEN-4; i>=0; i--) {	X[i]=NN[j--]; if(j<0) j=N-1;}//zݒ
	if(NN[j]>=0x80) X[0]++;//̒l0x80ȏ̂ƂŏI1ZiȂƂj
}				//@1Čオ肷̂0xFFB̏ꍇAO0AƂׂłB
void NFrevMini(NFloat X, int N){						// Ȓl̋t(1`16)
	switch(N){	// ZgƍŉʃoCg邽߂̊֐pӂB
	case  1 :NFsetFrac(X, 1, 0x10, 1, 0x00); break;							// 1/ 1
	case  2 :NFsetFrac(X, 0, 0x80, 1, 0x00); break;							// 1/ 2
	case  3 :NFsetFrac(X, 0, 0x55, 1, 0x55); break;							// 1/ 3
	case  4 :NFsetFrac(X, 0, 0x40, 1, 0x00); break;							// 1/ 4
	case  5 :NFsetFrac(X, 0, 0x33, 1, 0x33); break;							// 1/ 5
	case  6 :NFsetFrac(X, 0, 0x2A, 1, 0xAA); break;							// 1/ 6
    case  7 :NFsetFrac(X, 0, 0x24, 3, 0x92, 0x49 ,0x24); break;				// 1/ 7
    case  8 :NFsetFrac(X, 0, 0x20, 1, 0x00); break;							// 1/ 8
    case  9 :NFsetFrac(X, 0, 0x1C, 3, 0x71, 0xC7, 0x1C); break;				// 1/ 9
    case 10 :NFsetFrac(X, 0, 0x19, 1, 0x99); break;							// 1/10
    case 11 :NFsetFrac(X, 0, 0x17, 5, 0x45, 0xD1, 0x74, 0x5D, 0x17); break;	// 1/11
	case 12 :NFsetFrac(X, 0, 0x15, 1, 0x55); break;							// 1/12
	case 13 :NFsetFrac(X, 0, 0x13, 3, 0xB1, 0x3B, 0x13); break;				// 1/13
	case 14 :NFsetFrac(X, 0, 0x12, 3, 0x49, 0x24, 0x92); break;				// 1/14
    case 15 :NFsetFrac(X, 0, 0x11, 1, 0x11); break;							// 1/15
    case 16 :NFsetFrac(X, 0, 0x10, 1, 0x00); break;							// 1/16
	default :NFsetFrac(X, 1, 0x10, 1, 0x00);
				printf("̒l͗pӂĂ܂ 1/ %d", N);break;
	}
}
void NF1Ep10(NFloat X){//  1E+10̌Œlݒ
	int i=NFLOATLEN-1;	X[i--]=0x00; X[i--]=0x09; //@w
	X[i--]=0x25; X[i--]=0x40; X[i--]=0xBE; X[i--]=0x40;
	while(i>=0)X[i--]=0;
}
void NF1Ep20(NFloat X){//  1E+20̌Œlݒ
	int i=NFLOATLEN-1;	X[i--]=0x00; X[i--]=0x11;//w
	X[i--]=0x56; X[i--]=0xBC; X[i--]=0x75; X[i--]=0xE2;X[i--]=0xD6; X[i--]=0x31;
	while(i>=0)X[i--]=0;
}
void NF1Em10(NFloat X){//  1E-10̌Œlݒ(x4oCgx)
	int i=NFLOATLEN-1; X[i--]=0x7F; X[i--]=0xF8;//w
	X[i--]=0x47; X[i--]=0x6B; X[i--]=0x89; X[i--]=0xC9;
	while(i>=0)X[i--]=0;
}
void NF1Em20(NFloat X){//  1E-20̌Œlݒ(x4oCgx)
	int i=NFLOATLEN-1; X[i--]=0x7F; X[i--]=0xF0;//w
	X[i--]=0x16; X[i--]=0xE7; X[i--]=0xC0; while(i>=0)X[i--]=0;
}
void NFpmax(NFloat X){									// őlݒ
	int i=0;while(i<NFLOATLEN-1)X[i++]=0xFF;X[i]=0x3F;
}
void NFmmax(NFloat X){									// ̐Βlő
	int i=0;while(i<NFLOATLEN-1)X[i++]=0xFF;X[i]=0xBF;
}
void NFpmin(NFloat X){									// ŏlݒ
	NFclear(X);	X[NFLOATLEN-1]=0x40;X[NFLOATLEN-2]=0x00;X[NFLOATLEN-3]=0x10;
}
int NFcheckUnderFlow(NFloat R, int expR){				//A_[t[`FbN
	if(expR<0) {if(expR<0xFFFFC000){NFclear(R);return 0;return 1;}} 
	return 0;
}
int NFcheckOverFlow(int expR, char Msg[],int MsgPrint){//wݒ莞̃I[ot[`FbN
	if(expR<=0x3FFF) return 0;//I[ot[ĂȂΐ
	if(MsgPrint){//I[ot[ĂꍇAMsgPrint=0(false)w肷B
		char Str[256]; char Msg2[512]="\n*** ";	
		sprintf(Str,"ŃI[ot[N܂B16^%d>16^%d(0x3FFF)",expR,0x3FFF);
		strcat(Msg2, Msg);strcat(Msg2,Str);printf(Msg2);
	}
	return 1;
}
int NFcheckAndSetExp(NFloat R, int Flag, int expR, char Msg[], int MsgPrint ){//wݒ
	if(NFcheckUnderFlow(R, expR)) return 0;		// A_[t[`FbN
	int RT=NFcheckOverFlow(expR,Msg, MsgPrint);	// I[ot[`FbN
	if(RT) expR=0x3FFF;							// I[ot[̂Ƃwől
	NFsetFlagExp(R,Flag,expR); NFnomal(R);		// w̐ݒ
	return RT;
}
//------ ({) ----------------------------------------------------------------
int NAadd(NFloat R, NFloat X, NFloat Y){				// ΒlZ
	NFloat A, B; NFcopy(A,X); NFcopy(B,Y); NFnomal(A);NFnomal(B);NFcopy(R, A);
	int expA=NFgetExp(A), expB=NFgetExp(B), expR=expA;int dexp=expA-expB;
	if     (dexp>0) NFlowShift(B, dexp);				// A傫ƂBʃVtg
	else if(dexp<0) { expR= expB; NFlowShift(R,-dexp);} // B傫ƂA(R)ʃVtg
	unsigned int XX=0;									// Zȉl 0j
	for(int i=0;i<NFLOATLEN-2;i++){
		XX=(unsigned int) R[i] +(unsigned int)B[i]+ XX; // ʂ̌XX
		R[i]=(unsigned char) XX; XX>>=8;			// 8rbgBݒ
	}
	if(XX!=0){						// ꕪcA16i1EVtgA
		expR++; NFlowShift(R,1);	// ꕪ擪ɋlߍ݁Aw1JEgAbv
		R[NFLOATLEN-3] = (R[NFLOATLEN-3] & 0x0F) | (XX<<4);
	}
	return NFcheckAndSetExp(R, false, expR, "Z", true);//@wݒƐK	
}
void NFsubElm(NFloat R, NFloat B, int MX){				// Z{(w)
	unsigned int X=0;							// ʂŎ؂肽̏l 0
	for(int i=0;i<=MX;i++){
		X=(unsigned int) B[i] + X;				// lɉʂŎ؂肽B
		if(R[i]<X){ R[i]+=(unsigned char)( 0x100-X);X = 1;}		// ʂ 1 ؂
		else      {	R[i]-=(unsigned char) X        ;X = 0;}		// ؂肽Ȃ
	}
}
int NAsub(NFloat R, NFloat X, NFloat Y){				// ΒlZ(|X||Y|O)
	if(NAeq0(Y)){NFcopy(R,X);return 0;}	if(NAeq0(X)){NFcopy(R,Y);return 0;}
	NFloat A, B; NFcopy(B,Y);NFcopy(A, X); NFnomal(A);NFnomal(B);
	int expA=NFgetExp(A), expB=NFgetExp(B), expR=expA; int dexp=expA-expB;//w
	if(dexp<0) {printf("\n** G[@ΒlZ|A||B|OłB"); return 0;}
	if(dexp>0) NFlowShift(B, dexp);
	NFsubElm(A, B,NFLOATLEN-3);		//Zs
	int RT=NFcheckAndSetExp(A, false, expR, "Z", true);//@wݒƐK	
	NFcopy(R,A);return RT;
}
void NFclearMltTmp(multTemp X){for(int i=0; i<NMULTTEMP;i++) X[i]=0;}// Ɨ̈NA
void NFmltEm(NFloat Tmp, NFloat A, unsigned char BCH){				 // Z{
	unsigned int B=(unsigned int)BCH, X=0;							 //   (w]Ȃ)
	for(int i=0;i<NFLOATLEN-2; i++){ X=A[i]*B+X; Tmp[i]=(unsigned char)X; X>>=8;}
	Tmp[NFLOATLEN-2]=X;
}
int NAmlt(NFloat R, NFloat A,NFloat B, int MsgPrint){// ΒlZ
	// ZʂĂxႪȂꍇ, MsgPrint  0 w肷B
	NFnomal(A);NFnomal(B); NFloat Tmp; multTemp XR; NFclearMltTmp(XR);
	int expA=NFgetExp(A), expB=NFgetExp(B), expR=expA+expB;
	for(int i=0;i<NFLOATLEN-2; i++){			// B̌ŌJԂ
		NFmltEm(Tmp,A,B[i]); unsigned int DT=0;	// Bꌅ̏ZAʒuŉZ
		for(int j=0;j<NFLOATLEN-1;j++){
			DT=XR[i+j]+Tmp[j]+DT; XR[i+j]=(unsigned char)DT; DT>>=8;
		}
		XR[i+NFLOATLEN-1]+=DT;								// ꕪ̉Z
	}
	int IP=NMULTTEMP-1, XX=0;								// ʒu
	if(XR[IP]>=16) expR+=2; else if(XR[IP]!= 0){ expR++; XX=XR[IP];IP--;} else IP--;
	for(int i=NFLOATLEN-3;i>=0;i--,IP--)R[i]=XR[IP];		//ʗ̈Ɉڂ
	if(XX!=0) {NFlowShift(R,1); R[NFLOATLEN-3]|= XX<<4;}	//ꂽlݒ
	return NFcheckAndSetExp(R, false, expR, "Z", MsgPrint);
}
int NAmlt(NFloat R, NFloat A,NFloat B){			// ΒlZiʏ̏Zj
	return NAmlt(R,A,B, true);
}
void set4bitUnit(NFloat X,int id, unsigned char setData){// 4rbgPʂ̒lݒ
	int i=NFLOATLEN-3-id/2, idm=id %2, dt=setData & 0x0F;
	if(i<0 || i>NFLOATLEN-3) return;
	if(idm==0) X[i] = (X[i] & 0x0F) |(dt<<4); else X[i] = (X[i] & 0xF0) | dt;
}
int NAdivFail(NFloat R,NFloat Tmp){						 // Zs̔
	for(int i=NFLOATLEN-2;i>=0;i--){
		if(R[i]>Tmp[i]) return false; else if(R[i]<Tmp[i]) return true;
	}
	return false;
}
void NFsmall(NFloat X, NFloat A){// 덷␳̒liwōŒrbgPj
	for(int i=1;i<NFLOATLEN-2;i++) X[i]=0;
	X[0]=1;	NFsetFlagExp(X, NFgetFlag(A),NFgetExp(A));	NFnomal(X);
}
int NAdiv(NFloat Q, NFloat X, NFloat Y){					// ΒlZ
	if(NAeq0(X)){ NFclear(Q); return 0;}	// X==0̂Ƃ[ԋp
	if(NAeq0(Y)){ NFpmax  (Q); return 2;}	// B==0̂Ƃ[foCh
	// K(p邽 X, Y ʌ Q NA)
	NFloat R, B; NFcopy(R, X); NFcopy(B, Y);NFclear(Q); 
	int expA=NFgetExp(R), expB=NFgetExp(B), expQ=expA-expB+1;//w̎o
	NAclrFlagAndExp(R); union charINT AA, BB; NFloat Tmp;NFclear(Tmp);
	BB.CHAR[1]=0 ; BB.CHAR[0]=B[NFLOATLEN-3];	// ʐݒ
	for(int i=0; i<NFDIVLOOP;i++){
		AA.CHAR[1]=R[NFLOATLEN-2]; AA.CHAR[0]=R[NFLOATLEN-3]; unsigned int V;
		if(AA.SINT<BB.SINT) V=0;				// ʌ(A>B̂Ƃ0)
		else{
			V=AA.SINT/BB.SINT;NFmltEm(Tmp,B,V);	//ʌ폜/ʂƂ
			while(V!=0 && NAdivFail(R,Tmp)){	//ŝƂʌ
				V--; if(V==0) break; NFmltEm(Tmp,B,V);		//ʂōăgC
			}
			if(V!=0)NFsubElm(R,Tmp, NFLOATLEN-2);			// ʌ
		}
		set4bitUnit(Q, i, V); NFupShift4(R, NFLOATLEN-2);   //̈ʒǔʐݒ
		if(R[NFLOATLEN-2] ==0 && NAeq0(R)) break;
	}
	return NFcheckAndSetExp(Q, false, expQ, "Z" ,true);
}
//----------------------- Px֌W -----------------------------------
void NFSFloat(NFloat X, SFloat A){//@PxNFloatɕϊ
	unsigned char Flag= A.DT.CH[3] & 0x80;			//ݒ
	unsigned char EXP = A.DT.CH[3] & 0x7F, E0=0x00;	//wϊ
	if((EXP & 0x40)!=0) {EXP |= 0x80; E0=0x7F;}		//̎ŵƂ
	int i=NFLOATLEN-1; X[i--]=E0; X[i--]=EXP;		//wړ
	for(int k=2; k>= 0; k--) X[i--]=A.DT.CH[k];		//ړ
	while(i>=0) X[i--]=0;							//c0ݒ
	X[NFLOATLEN-1] |= Flag;							//ݒ
}
SFloat NFtoSFloat(NFloat X){// NFloatPxɕϊ
	NFloat A; NFcopy(A,X);int MX=NFLOATLEN-1;				//ݒ		
	SFloat R; R.DT.INT=0; unsigned char Flag= A[MX]& 0x80;
	if(A[MX-5]>=0x80){								//PxɓȂʒuľܓ
		NFloat HS;NFcopy(HS,A);	HS[MX-2]=0;HS[MX-3]=0;HS[MX-4]=0; NAadd(A,A,HS);
	}
	unsigned char E0  = A[MX]& 0x7F, EXP = A[MX-1];			//wϊ
	if(E0==0x00){ if((EXP & 0x80)!=0)printf("*** l傫܂(NFloat to SFloat)");}
	else if((E0 & 0x40)!=0) { if( E0!=0 || (EXP & 0x80)==0) return R; }//ŵƂ
	else printf("*** l傫܂(NFloat to Single)");	//w擪̂Ƃ
	R.DT.CH[3] = ((EXP & 0x7F) | Flag); MX=NFLOATLEN-3;		//wړ
	R.DT.CH[2] = A[MX--]; R.DT.CH[1] = A[MX--];	R.DT.CH[0] = A[MX--];//ړ
	return R;
}
SFloat NFcallSF(int (*fun)(NFloat x,NFloat y,NFloat z),		//NFloat֐Ăяo
				SFloat sy, SFloat sz){						//   3 int
	NFloat X, Y, Z; NFSFloat(Y, sy); NFSFloat(Z, sz);	fun(X, Y, Z); 
	return NFtoSFloat(X);
}
SFloat NFcallSF(void (*fun)(NFloat x,NFloat y,NFloat z),	//NFloat֐Ăяo
				SFloat sy, SFloat sz){						//   3 void
	NFloat X, Y, Z; NFSFloat(Y, sy); NFSFloat(Z, sz);	fun(X, Y, Z); 
	return NFtoSFloat(X);
}
SFloat NFcallSF(int (*fun)(NFloat x,NFloat y), SFloat sy){	//NFloat֐Ăяo
	NFloat X, Y; NFSFloat(Y, sy); fun(X, Y); 				//   2 int
	return NFtoSFloat(X);
}
SFloat NFcallSF(void (*fun)(NFloat x,NFloat y), SFloat sy){	//NFloat֐Ăяo
	 NFloat X, Y; NFSFloat(Y, sy); fun(X, Y); 				//   2 void
	return NFtoSFloat(X);
}
int NFstring(NFloat nF, char str[]);
SFloat NFstring(char str[]){								//SFloatɕϊ
	NFloat X; NFstring(X, str); return NFtoSFloat(X);		//  Pxp
}
int NFtoExpStr(NFloat DT, char ch[], int Np,int SpIns);
int NFtoExpStr (SFloat A, char ch[], int Np, int SpIns)	{	//E}99`Pxp
    NFloat DT;NFSFloat(DT,A); return NFtoExpStr (DT, ch, Np, SpIns);
}
int NFtoExpStr (SFloat A, char ch[])	{					//E}99`Pxp
	return NFtoExpStr (A, ch, 5, false);
}
int NFtoString(SFloat A, char ch[], int Np, int CmIns){		//ϊPxp
	 NFloat DT;NFSFloat(DT,A); return NFtoExpStr (DT, ch, Np, CmIns);
}
int NFtoString(SFloat A, char ch[]){//ϊPxpiŒAR}Ȃj
	 return NFtoString( A, ch,5, false);
}
//------ (Ƃ̕ϊ) -----------------------------------------------
void NFchar(NFloat stNo, char ch){ NFintTo(stNo, ch-'0');}
	int NFstring(NFloat nF, char str[]){		// 񂩂NFloat쐬
	int flag=0,ip=0; NFloat F10, F1, stNo,R,FX,F1by10; 
	NFintTo(F10,10); NFintTo(F1,1); NFrevMini(F1by10,10);
	while(str[ip]!=0 &&(str[ip]==' ' || str[ip]=='@'))ip++;	// 󔒃XL
	if(str[ip]=='+') ip++; else if(str[ip]=='-'){ip++; flag=1;} // (-)
	while(str[ip]!=0 &&(str[ip]==' ' || str[ip]=='@'))ip++;	// 󔒃XL
	NFintTo(nF,0);											    // (l0j
	while((str[ip]>='0' && str[ip]<='9')||str[ip]==','){// ̂Ƃʌ*10+̌
		if(str[ip]!=','){
			NAmlt(R,nF,F10); NFchar(stNo, str[ip]); NAadd(nF,R, stNo); ip++;
		}
	}
	if(str[ip]=='.'){	// _Ȃ΁AȉȉƂ݂ȂB
		ip++;			// (F1)͏l 1 ƂA 10(F10) ŏċ߂.
		while(str[ip]>='0' && str[ip]<='9'){// ̂ƂAʌ + ̌̒l * 
			NAmlt(F1, F1, F1by10); NFchar(stNo, str[ip]);   // F1 = F1/10; stNo = ̒l
			NAmlt(FX, F1, stNo)  ; NAadd(nF, nF, FX); ip++; // nF = nF + F1 * stNo 
		}
	}
	NFnomal(nF); NFsmall(FX,nF); NAadd(nF,nF,FX); // ŉʃrbg 1 ĕ␳
	if(flag) nF[NFLOATLEN-1]|=0x80;	return ip;          // ʒu̕ԋp
}
void NFabs(NFloat DT){ DT[NFLOATLEN-1] &= 0x7F;}		//  Βl
void NFabs(NFloat A, NFloat B){ NFcopy(A, B);NFabs(A);}	//  Βl A=|B|
int NFintToStr(int DT,char ch[]){						//  當񐶐
	char str[512];int ip=0,d=DT,j=0; // 10 ̏]str[]Ɋi[(ɂĂ)
	if(d==0)ch[j++]='0';
	else{
		while(d >0){str[ip++]=(d %10)+'0'; d/=10;}	// t]`str[]ɓB
		while(ip>0) ch[j++]=str[--ip];				// ̐ݒ
	}
	ch[j++]=0;return j;
}
int NFloatZeroExpStr(char ch[], int Np,int SpIns){		//  0̂ƂE`
	int num=0; ch[num++]=' '; ch[num++]='0';ch[num++]='.';	// (0.00000000E+0)
	for(int i=0;i<Np;i++){// _ȉ̌0 
		ch[num++]='0'; if(SpIns && i != 1 && (i%5)==4) ch[num++]=' ';
	}
	ch[num++]='E';ch[num++]='+';ch[num++]='0';ch[num++]=0; return num;
}
void NFminiV(NFloat X){
	NFclear(X);X[NFLOATLEN-1]=0x41;X[NFLOATLEN-2]=0x00;X[NFLOATLEN-3]=0x10;
}
int NFtoExpStr(NFloat DT, char ch[], int Np,int SpIns){//  E}n `̕񐶐
	int num=0, E=0; NFloat A,C1,C10, FX; NFcopy(A,DT);		   //ݒ@A=DT
	NFabs(A); if(NAeq0(A)) return NFloatZeroExpStr(ch, Np,SpIns);	//0̂Ƃ`o
	NFintTo(C1,1);NFintTo(C10,10);	
	NFintTo(C1,1); if(NFgetFlag(DT)) ch[num++]='-'; else ch[num++]=' ';//
	// 傫Ȓl1E+10
	NFloat Cp10,Cm10,Cp20,Cm20;NFcopy(Cp10,C1);NFcopy(Cm10,C1);
	for(int i=0;i<10;i++){NAmlt(Cp10,Cp10,C10);NAdiv(Cm10,Cm10,C10);}//10}10
    NAmlt(Cp20, Cp10,Cp10);NAmlt(Cm20, Cm10,Cm10);			         //10}20
	while(NAcmp(A,Cp20)>=0){E+=20; NAdiv(A,A, Cp20);}		//10^20ɂ
	while(NAcmp(A,Cp10)>=0){E+=10; NAdiv(A,A, Cp10);}		//10^10ɂ
	NFloat Cmin; NFminiV(Cmin); 
	if(NAcmp(A,Cmin)>0){ //@ɏȒlł͕␳Ȃ
		// 邨ꂪȂ̂ŁA1`9̒lɂOɌľܓ
		NFrevMini(FX,2); NAmlt(FX,A,FX);         // FX = A/2̌vZ
		for(int i=0; i<=Np;i++) NAdiv(FX,FX,C10);	// FX=(A / 2) *(10^(-))
		NAadd(A,A,FX);								//␳lZ
	}
	// 1`9̒lɂ
	while(NAcmp(A,C10)>=0){E++; NAdiv(A,A, C10);}			//10ɂ
	while(NAcmp(A,Cm20)<0){E-=20; NAmlt(A,A, Cp20);}		//10^-20ȏɂ
	while(NAcmp(A,Cm10)<0){E-=10; NAmlt(A,A, Cp10);}		//10^-10ȏɂ
	while(NAcmp(A,C1 )< 0){E--; NAmlt(A,A, C10);}			//1ȏɂ
	int id=NFgetExp(A); if(id!=1) {printf("System Error"); return num;}	// id=1̂͂
	ch[num++]='0' + (A[NFLOATLEN-3]>>4); ch[num++]='.';		// Ə_ݒ
	A[NFLOATLEN-3] &= 0x0F;									// NA
	for(int i=0;i<Np;i++){ //i10悶Ȃ琮ƂȂlPƂj
		NAmlt(A,A, C10); id=NFgetExp(A);		// 10 悶ʂ̐ 0 ` 9 ̒l 
		if(id<=0) ch[num++]='0';			// 1  0
		else {ch[num++]='0' + (A[NFLOATLEN-3]>>4); A[NFLOATLEN-3] &= 0x0F;}
		if(SpIns && i != 1 && (i%5)==4) ch[num++]=' ';
	}
	ch[num++]='E'; if(E>=0) ch[num++]='+';else{ch[num++]='-';E=-E;}		//w
	return NFintToStr(E,ch+num) + num;									//ԋp
}
void NFfix(NFloat A){// Jbg(w~4 bitscʂ 0 Zbg)
	int expA=NFgetExp(A);	if(expA<=0) {NFclear(A); return;}//w 0 ȉ̂ƂNA
	int N=(expA-1)/2; if((NFLOATLEN-3-N)<0) return;	//Ȃ
	if(expA % 2) A[NFLOATLEN-3-N] &= 0xF0;			//4bitsPʊԖڂ̏
	for(int i=NFLOATLEN-4-N;i>=0;i--) A[i]=0;		//ʂ 0 Zbg
	NFnomal(A);
}
int NFtoString(NFloat DT, char ch[], int Np, int cmIns){//  _̕񐶐
	char Str[2000];int ip=0, istr=0, CDT,expA;
	NFloat A, C01,C05, C10, A1, A2, AD, AM; NFcopy(A,DT); NFintTo(C10,10);
	if(NFgetFlag(A))ch[ip++] = '-'; else ch[ip++] = ' ';//ݒ
	NFsetFlag(A,0);  NFrevMini(C01,10); NFrevMini(C05,2);//C01 = 1/10, C05=1/2
	for(int i=0;i<Np; i++) NAmlt(C05,C05,C01);// \ľܓp萔ݒ
	NAadd(A, A, C05); NFcopy(A1,A); NFfix(A1);// ȉJbg  A1
	while(!NAeq0(A1)){
		NAmlt(AD,A1,C01);NAadd(AD,AD,C05);NFfix(AD);// 10ŏ폜
		NAmlt(A2,AD,C10); NAsub(AM,A1,A2);			// 10悶lō
		expA=NFgetExp(AM);							// 1̈ʂStr[]ɕۑ
		if     (expA<=0) Str[istr++]='0';			// iɒ)
		else if(expA==1) { CDT=AM[NFLOATLEN-3]>>4; Str[istr++]=CDT+'0';}
		else {printf("** ϊ@G[");  Str[istr++]='#';break;}
		NFcopy(A1,AD);
	}
	for(int i=istr-1; i>=0; i--){	//̕ݒ(StrړƃR}})
		ch[ip++]=Str[i];if(cmIns && (i!=0) && ((i % 3)==0)) ch[ip++]=',';
	}
	ch[ip++]='.'; NFcopy(A2,A); NFfix(A2);NAsub(A,A,A2);//
	for(int i=0;i<Np;i++){								//̕ݒ
		NAmlt(A,A,C10); int Dt=0, expA=NFgetExp(A);		// 10悶
		if     (expA<=0) ch[ip++]='0';					// 1̈ʂ𕶎ɂ
		else if(expA==1) {Dt=A[NFLOATLEN-3]>>4; ch[ip++]=Dt+'0';}
		else {printf("\n ** ϊ@G["); Str[istr++]='#';break;}
		if(expA==1) {A[NFLOATLEN-3] &=0x0F; NFnomal(A);}// A = A-int(A)Ɠ
	}
	ch[ip++]=0;	return ip;
}
void NFprint(char preMsg[], NFloat X, int Np){				//  NFloat\
	printf(preMsg);char Str[512];					// preMsgɐs镶,
	NFtoExpStr(X, Str,Np,true); printf("%s",Str);	// Npɏ_ȉwj
}
void NFprint(char preMsg[], NFloat X){ NFprint(preMsg,X, 5);}
void NFprintF(char preMsg[], NFloat X, int Np,int CmIns){	//  NFloat\
	printf(preMsg);char Str[512];					// preMsgɐs镶,
	NFtoString(X, Str,Np,CmIns); printf("%s",Str);	// Npɏ_ȉw
}
void NFprintF(char preMsg[], NFloat X){ NFprintF(preMsg,X, 5,true);}
void NFintMax(NFloat X){									// őlݒ
    int i = NFLOATLEN-1; X[i--] = 0; X[i--] = 8; 
	X[i--] = 0x7F;X[i--] = 0xFF;X[i--] = 0xFF;X[i--] = 0xFF;
	while(i>=0) X[i--] = 0;
}
int NFcheckMaxInt(NFloat X){//  16i8̏ꍇ̏(8ȊȌꍇ 0)
	union IX{ int INT; unsigned char CH[4];} DT;//ϊpp
	int i=NFLOATLEN-1;int Flag=0, RT=0;	DT.INT=0;
	if(X[i]==0x80 || X[i]==0){//擪0x80܂0x00̂Ƃɕϊ\
		i--; 
		if(X[i--] == 0x08){//ʂ2oCgڂ08̂Ƃ16i8
			for(int j=3; j>=0; j--) DT.CH[j]=X[i--];//4oCgړ
			i=NFLOATLEN-1;
			if(X[i]==0x80 && (DT.INT != 0x80000000)) return DT.INT;	//ő
			if((DT.INT & 0x80000000)!=0) printf("l傫܂");
			 DT.INT &= 0x7FFFFFFF; if(X[i]==0x80) DT.INT= -DT.INT;//8̕ϊ
		}
	}
	return DT.INT;
}
int NFtoAbsInt(NFloat X){	//  NFloat𐮐ɕϊ
	int V= NFcheckMaxInt(X); if(V!=0) return V;				//16i8̂Ƃ̌vZ
	NFnomal(X); int expA=NFgetExp(X); if(expA<=0) return 0;	//ɂƂ 0
	NFloat IMX; NFintMax(IMX);                              //ől
	if(NAcmp(X,IMX)>0){ printf("*** ւ̕ϊ͈̔͊Oł"); return 0;}
	int flag=NFgetFlag(X), i;								//̕o
	for(i = NFLOATLEN-3, V=0; expA>=2; i--, expA -= 2) V = V * 256 + X[i];
	if(expA==1) V = V * 16 + (X[i] >> 4);// 256Pʏ1]̏
	return (flag ? -V: V) ;	
}
int NFtoInt(NFloat X){//  NFloat琮ւ̕ϊi܂ށj
	int MX=NFLOATLEN-1;//̐Βlől̏ꍇA]ŃI[ot[̂ōŏɏB
	if(X[MX]==0x80 && X[MX-1]==0x08 && X[MX-2]>=0x80) return 0x80000000;
	NFloat A; NFcopy(A,X); int Flag=A[MX] & 0x80; A[MX] &= 0x7F;
	int R=NFtoAbsInt(A); if(Flag!=0) R = -R;
	return R;
}
//-------- (lZ) --------------------------------------------------
void NFadd(NFloat X, NFloat A, NFloat B){//̂ƂZAقȂƂZ
	if(NAeq0(B)){NFcopy(X,A); return;} if(NAeq0(A)){NFcopy(X,B); return;}
	int Aflag=NFgetFlag(A), Bflag=NFgetFlag(B);//  (+|A|)+(-|B|))=|A|-|B|=-(|A|-|B|)
	if(Aflag==Bflag) { NAadd(X,A,B);NFsetFlag(X,Aflag);return;}// (-|A|)+(+|B|)=-(|A|-|B|)
	int cmp; if((cmp=NAcmp(A,B))==0) {NFintTo(X,0);return;}
	if(cmp>0){ NAsub(X,A,B);NFsetFlag(X,Aflag);return;}// |A|>|B|̂ƂA̕
	else     { NAsub(X,B,A);NFsetFlag(X,Bflag);return;}// |A|<|B|̂ƂB̕
}
void NFsub(NFloat X, NFloat A, NFloat B){//قȂƂZÂƂZ
	if(NAeq0(B)){NFcopy(X,A); return;}				// B = 0 ̂ƂA = A
	if(NAeq0(A)){NFcopy(X,B); NFminus(X);return;}	// A = 0 ̂ƂA = -B
	int Aflag=NFgetFlag(A), Bflag=NFgetFlag(B);	//  (-|A|)-(-|B|))=|B|-|A|=-(|A|-|B|)
	if(Aflag!=Bflag) { NAadd(X,A,B);NFsetFlag(X,Aflag);return;}// (+|A|)-(+|B|)=-(|B|-|A|)
	int cmp; if((cmp=NAcmp(A,B))==0) {NFintTo(X,0);return;}
	if(cmp>0){ NAsub(X,A,B);NFsetFlag(X,Aflag);return;} // |A|>|B|̂ƂA̕
	else     { NAsub(X,B,A);NFsetFlag(X,!Bflag);return;}// |A|<|B|̂ƂB̋t
}
void NFmlt(NFloat X, NFloat A, NFloat B){//قȂƂÂƂ
	int FA=NFgetFlag(A), FB=NFgetFlag(B);NAmlt(X,A,B); NFsetFlag(X,FA!=FB);
}
void NFdiv(NFloat X, NFloat A, NFloat B){//قȂƂÂƂ
	int FA=NFgetFlag(A), FB=NFgetFlag(B);NAdiv(X,A,B); NFsetFlag(X,FA!=FB);
}
int NFcmp(NFloat A,NFloat B){//l傫̔r
	int A0=NAeq0(A), B0=NAeq0(B); if(A0 && B0) return 0; // 0̂Ƃ
	int AF=NFgetFlag(A), BF=NFgetFlag(B);
	if(A0){if(BF) return  1;else return -1;} // A==0 ̂Ƃ B ̕Ŕ
	if(B0){if(AF) return -1;else return  1;} // B==0 ̂Ƃ A ̕ŋt
	if(AF){if(BF)return -NAcmp(A,B);	else  return -1;}// ÂƂ
	else  {if(BF)return 1;	else  return NAcmp(A,B);} // ÂƂ
}
void NFadd(NFloat A, NFloat B){ NFadd(A,A,B);}	// A += B
void NFsub(NFloat A, NFloat B){ NFsub(A,A,B);}	// A -= B
void NFmlt(NFloat A, NFloat B){ NFmlt(A,A,B);}	// A *= B
void NFdiv(NFloat A, NFloat B){ NFdiv(A,A,B);}	// A /= B
//---------------------- ց@@ -------------------------------------------
void compPai(NFloat PI){//  ΂̌vZ   4/=1+1^2/(3+2^2/(5+3^2/7+4^2/c)))
	int NN=NFLOATLEN*50/16; NFloat ii, C4,NX; NFintTo(PI,NN);
	for(int i=NN;i>=1;i--){ // PI=1+1^2/(3+2^2/(5+3^2/7+4^2/c)̌vZ
		NFintTo(NX, i*2-1);	NFintTo(ii,i*i); 
		NAdiv(ii,ii,PI); NAadd(PI, NX,ii);
	}
    NFintTo(C4,4); NAdiv(PI,C4,PI); //  = 4/PI
}
void compNapier(NFloat E){//  lCsA e ̌vZ(}N[ɂ)
	NFloat A, bE,N,C1;NFintTo(C1,1); 
	NFclear(E); NFcopy(A,C1);NFcopy(N,C1);
	do{	  // e = 1+ 1/1! + 1/2! + 1/3! + 1/4! + c
		NFcopy(bE,E); NAadd(E,E,A); NAdiv(A,A,N);NAadd(N,N, C1);
	}
	while(NAcmp(E,bE)!=0);
	return;
}
void log2(NFloat ln2){	// log 2 vZ(1/(n*2^n)̌p)
	NFloat N, C1, C2, D, bln2, X; NFintTo(C1,1);NFintTo(C2,2); 
	NFcopy(N,C1); NFcopy(D,C1);NFclear(ln2);
	do{// 1/(1 * 2^1) + 1/(2 * 2^2) + 1/(3 * 2^3) + 1/(4 * 2^4) + 1/(5 * 2^5) + c
		NFcopy(bln2,ln2); NAdiv(D,D,C2); NAdiv(X,D,N); // D=1/2^N, X=1/(2^N * N)
		NAadd(ln2,ln2, X); NAadd(N,N,C1);
	}
	while(NAcmp(bln2,ln2)!=0);
}
void cut2Pai(NFloat A){	//  px2Ε
	NFloat C1, C2, DP, AX, AI,AA; NFintTo(C2,2); NFintTo(C1,1); 
	NAmlt(DP,PAI,C2);// AA = AA - 2 * fix(AA/2)i2΂̐{j
	NFdiv(AX,A,DP); NFfix(AX); NFmlt(AI,AX,DP);	NFsub(AA,A,AI);
	while(NFgetFlag(AA)) NFadd(AA,AA,DP);			//c -2<AA< 0 ̏
	while(NFcmp(AA,DP)>0) NFsub(AA,AA,DP);	//vZ덷Ŏc AA=2΋ߕӂ̏
	NFcopy(A,AA);								//Aɒlԋp
}
/*
void sqrt(NFloat Z,NFloat X){					// (2T@j
	int NMAX=NFLOATLEN*256/16; if(NAeq0(X)){NFclear(Z); return;} // 0̂Ƃ
	NFloat XX, C1, C2; NFcopy(XX,X); NFintTo(C1,1);NFintTo(C2,2);
	int expA=NFgetExp(XX),expB, m;	//w𒲐 16^m*sqrt(x*16^s)̌`ɂ
	if(expA>0)m=(expA+1)/2; else m=(expA-1)/2;//  s 1܂ 0
	expB=expA-m*2+2;				// vZ 1X255̒lɑ΂čŝŁA
	XX[NFLOATLEN-1]=0;XX[NFLOATLEN-2]=expB;	//wӂNȂB
	NFloat NN, N1, N2,C05, MZ;		// lݒ
	NFcopy(N2,XX);				    // JԂ񐔂Ȃ邽
	if(N2[NFLOATLEN-3]>=0x40) {		// 4 A< 16̂Ƃ 2sqrt(A)< 4 Ȃ̂
		N2[NFLOATLEN-3]=0x40;		// ŏʂ0x40傫Ƃ0x40
		NFcopy(N1,C2);				// 2ƂB
	}else NFcopy(N1,C1);			// ŏʂ0x40菬Ƃ1ƂB
	NFstring(C05,"0.5"); NAadd(Z,N1,N2); NAmlt(Z,Z,C05); // NAdiv(Z,Z,C2);
	for(int i=0;i<NMAX;i++){
		NAmlt(NN,Z,Z); int cmp=NAcmp(NN,XX);// 2vZČ̒lƔr
	    if     (cmp >  0) NFcopy(N2,Z);	// ʂ傫Ƃ N2 = l
		else if(cmp <  0) NFcopy(N1,Z);	// ʂƂ N1 = l
		else break;							// ʂƂ
		NAadd(Z,N1,N2);NAmlt(Z,Z,C05); // NAdiv(Z,Z,C2);// ēxԒlvZ
		if(NAcmp(Z,N1)==0 ||NAcmp(Z,N2)==0) break;//Ԓl㉺Ɠ
	}
	NFclear(MZ); MZ[NFLOATLEN-3]=0x10; NFsetFlagExp(MZ,0, m);//16^m
	NAmlt(Z,Z,MZ);							// 16^m 悶
}
*/

void sqrt(NFloat S, NFloat X){
	if(NFgetFlag(X))printf("\n sqrt error"); 
	NFloat C05,SS,T1,T2;
	NFstring(C05,"0.5");NFintTo(S,1);
	for(int i=0;i<500;i++){
		NFcopy(SS,S);NAdiv(T1,X,S);NAadd(T2,T1,S); NAmlt(S,T2,C05);//NAdiv(S,T2,C2);
		if(NAcmp(S,SS)==0)break;
	}
	//␳lZ
	//NFloat EP; NFintTo(C05,7);NAmlt(EP, S, MACHINE_EPS);NAmlt(EP, EP,C05);
	//NFadd(S,EP);
}
void sqrt2(NFloat Z,NFloat X){// (vZɂ@j
	// x2T@̕Ax2T@̂ق኱ǂ̂ŁA͍̗pȂB
	int NMAX=NFLOATLEN*256/16; if(NAeq0(X)){NFclear(Z); return;} // 0̂Ƃ
	NFloat DX, DDX, XX, C1,CX, C2, C05, MZ; NFcopy(XX,X); NFintTo(C1,1);NFintTo(C2,2);
	int expA=NFgetExp(XX),expB, m;	//w𒲐 16^m*sqrt(x*16^s)̌`ɂ
	if(expA>0)m=(expA+1)/2; else m=(expA-1)/2;//  s 1܂ 0
	expB=expA-m*2+2;				// vZ 1X255̒lɑ΂čŝŁA
	XX[NFLOATLEN-1]=0;XX[NFLOATLEN-2]=expB;	//wӂNȂB
	NFcopy(Z,C1); NFintTo(DX,16);NFrevMini(C05,2);
	while(NAcmp(DX,C1)>0){
		NAmlt(DDX,DX,DX); 
		while(NAcmp(XX,DDX)>0){	
			NFcopy(CX,XX);NAdiv(XX,XX,DDX); NAmlt(Z,Z,DX); 
			if(NAcmp(XX,CX)==0) break;
		}
		NAadd(DX,DX,C1);NAmlt(DX,DX,C05);
	}
	NFclear(MZ); MZ[NFLOATLEN-3]=0x10; NFsetFlagExp(MZ,0, m); //16^m
	NAmlt(Z,Z,MZ);							                  // 16^m 悶
}
void sin(NFloat SinA, NFloat Angle){	//  sin֐(PAI͌vZĂ)
	NFloat C2, HP, A, i,X,IB,C1, V,VX,bNsin;int Flag=0,Flag2=0;
	NFcopy(A,Angle); NFintTo(C2,2); NAdiv(HP,PAI,C2); cut2Pai(A);// 2΂
	if(NAcmp(A,PAI)>=0){ Flag=true; NAsub(A,A,PAI);}// Έȏ̎Aʕ
	if(NAcmp(A,HP)>=0) NAsub(A,PAI,A);				// /2ȏ̂Ƃl̊px
	NFintTo(C1,1); NFcopy(i,C1);NFcopy(X,C1);	// i=1, X=1;
	int Fl=0; NFcopy(V,A); NFcopy(SinA,A);			// V=A, sin=A;
	do{ // sin(x) = x - x^3/3! + x^5/5! - x^7/7! + c
		NFcopy(bNsin,SinA);	Fl=!Fl; NAadd(IB,i,C1);NAadd(i,IB,C1);
		NAdiv(X,X,IB);NAdiv(X,X,i);NFsetFlag(X,Fl);  // }N!
		NFmlt(V,V,A);NFmlt(V,V,A);NFmlt(VX,V,X); NFadd(SinA,VX);
	}
	while(NFcmp(bNsin,SinA)!=0);
	NFsetFlag(SinA,Flag);										// ΁`2Ε̒
}
void cos(NFloat CosA, NFloat Angle){	//  cos֐(PAI͌vZĂ)
	NFloat divC2, HP, A; NFcopy(A,Angle); // cos(A)=sin(A+/2) 
	NFrevMini(divC2, 2); NAmlt(HP,PAI,divC2); NFadd(A,A,HP); sin(CosA, A);
}
void tan(NFloat TanA, NFloat Angle){    //  tan֐
	NFloat SinA, CosA; sin(SinA,Angle); cos(CosA,Angle);// tan(A)=sin(A)/cos(A)
	NFdiv(TanA, SinA, CosA);
}
void Atan(NFloat Z, NFloat X){							//  ArctaňvZ
	int N = NFLOATLEN*100/16;	// }N[WJł͎x̂ŘAŌvZB	
	NFloat T, T2, C1,C2,C5, A,MC1, HP,AT,DF;NFcopy(T,X);NFsetFlag(T,0);
	NFintTo(MC1, -1);NFintTo(C1,1); NFintTo(C2, 2); NFintTo(C5,6); 
	if(NAcmp(T,C1)>0) NAdiv(T, C1, T);
	NFclear(A);NAmlt(T2, T, T);	// T^2͗\ߌvZĂ
	for(int i=N; i>=1; i--){			// A =i^2*T^2/(2*i+1 + A)
		NFloat ii, ii2; NFintTo(ii, i*i); NAmlt(ii, ii,T2);
		NFintTo(ii2, i*2+1); NAadd(A, ii2, A); NAdiv(A, ii, A);
	}	//@JԂvZł0`1ƂĂ̂ōŌɒ
	NAadd(A,A,C1); NAdiv(Z, T, A); NAdiv(HP,PAI,C2);
	if     (NFcmp(X,C1 )>0)	NFsub(Z, HP,  Z);
	else if(NFcmp(X,MC1)<0)	NFsub(Z,  Z, HP);
	else						NFsetFlag(Z,NFgetFlag(X));
	tan(AT,Z); NFsub(DF,X,AT); NFdiv(DF,DF,C5);NFadd(Z,Z,DF);
}
/*2017/08/03ASYPɂ\Ȑx悤ɂȂ̂ŕsvƂB
void Asin2(NFloat Z, NFloat X){//  0.92`1.0C-1.0`-0.92̂ƂArcSinvZ
	int Loop=NFLOATLEN*100/16; // (͈̔͂͌덷傫̂2T@Ƃ)
	NFloat N1, N2, XX, SH,C2; NFcopy(XX,X); NFsetFlag(XX,0); NFintTo(C2,2);
	NFloat C05, C075,C07, Cd7, C8; NFrevMini(C05,2); NFrevMini(Cd7,7); 
	NFstring(C075,"0.75"),NFstring(C07,"0.7");NFintTo(C8,8);
	// ** lݒ@(̂Pj							// N2=XX^2*/0.5
	if(NAcmp(XX,C075)>0){NAmlt(N2,XX,XX);NAmlt(N2,N2,PAI);NAmlt(N2,N2,C05);}
	else{ NAmlt(N2,XX,C8);NAmlt(N2,N2,Cd7); }               // N2=XX*8/7
	if(NAcmp(XX,C07)<=0) NFcopy(N1,XX);						// N1=XX
	else{ NAmlt(N1,XX,C2);NAsub(N1,N1,C07); }               // N1=XX*2-0.7
	// ** lݒ@(̂PjI
	// ** lݒ@(̂Q)
	//NFloat C93; NFstring("0.9306987302425770");
	//NFcopy(N1,XX); NAmlt(PD,PAI, C05);	// N1=XX
	//NAmlt(N2,XX,PD);					// N2=X*/2
	//NAadd(NM,N1,N2); NAmlt(NM,NM,C05);	// NM = (N1+N2)/2
	//if(NAcmp(XX,C093)>=0)NFcopy(N1, NM);// C93̒lɂ㉺l𒲐
	//else				 NFcopy(N2, NM);
	// ** lݒ@(̂QjI
	NAadd(Z,N1,N2); NAmlt(Z,Z, C05);int JD;	//NAdiv(Z,Z,C2);
	for(int i=0; i<Loop; i++){
		sin(SH,Z);JD=NFcmp(SH,XX);
		if(JD>0) NFcopy(N2,Z); else	if(JD<0) NFcopy(N1,Z); else break;
		NAadd(Z,N1,N2); NAmlt(Z,Z, C05); // Z = (N1 + N2) * 0.5
		if(NAcmp(Z,N1)==0)break;         // || NAcmp(Z,N2)==0) break;
	}
	NFsetFlag(Z, NFgetFlag(X));//Zbg
}
*/
void Asin(NFloat Z, NFloat X){							//  ArcsiňvZ
	NFloat C1,C05,MC1, MX, XX;NFintTo(C1,1);NFstring(C05,"0.5"); NFminus(MC1,C1);
	NFsub(MX,C1,MACHINE_EPS);
	if(NFcmp(X, MX)>=0){NFmlt(Z, PAI,C05); return;}
	NFsetFlag(MX,1);
	if(NFcmp(X, MX)<=0){NFmlt(Z, PAI,C05);NFminus(Z);return;}
	NFloat C09,MC09; NFstring(C09,"0.92");NFstring(MC09,"-0.92");
	//2017/08/03 ASYPɂsvƂȂ
	//if( (NFcmp(X,C09)>0 && NFcmp(X,C1  )<0)||	
	//	(NFcmp(X,MC1)>0 && NFcmp(X,MC09)<0)) Asin2(Z,X);
	//else {
		NFloat XD,XB,X2;// Asin(x)=atan(x/sqrt(1-x^2))
		NFmlt(X2,X,X);NFsub(XB, C1,X2);
		sqrt(XD,XB); NFdiv(XX,X,XD);
		Atan(Z,XX);
	//}
}
void Acos(NFloat Z, NFloat X){							//  ArccošvZ
	NFloat C05,DP,AS;NFstring(C05,"0.5");NFmlt(DP, PAI,C05);
	Asin(AS, X); NFsub(Z, DP,AS);
}
void myTan(NFloat A, NFloat X){// 
	if(NAeq0(X)) { NFintTo(A,0);	return;}// ApČvZB
	int N=NFLOATLEN*100/16, iflag=NFgetFlag(X);NFloat X2,C2,C1; 
	NFmlt(X2,X,X);NFintTo(C2,2);NFintTo(C1,1);NFintTo(A,0);
	for(int i=N;i>0;i--){// x^2/(3-cx^2/((2*i+1)-c   
		NFloat ii, OP1;  NFintTo(ii, 2*i+1); 
		NFsub(OP1, ii,A); NFdiv(A,X2,OP1); // A = X^2/((2*i+1)-A)
	}
	NFsub(A,C1,A); NFdiv(A,X,A);
	NFsetFlag(A,iflag);
}
void log(NFloat A, NFloat X){//  A=log(X)̌vZFLOG2log 2 ̒lvZς݂Ƃ
	if(NAeq0(X)) { NFpmax(A); NFsetFlag(A,true);	return;}// ApČvZB
	int N=NFLOATLEN*50/16; 
	NFloat XX,L, C1, C2, C16, Cx10000, dCx; NFcopy(XX,X); NFsetFlag(XX,false);
	NFclear(L); NFintTo(C1,1);NFintTo(C2,2);NFintTo(C16,16);
	NFintTo(Cx10000,0x10000); NFloat HxLOG2; NAmlt(HxLOG2,LOG2, C16);
	NAdiv(dCx,C1,Cx10000);		// 1XX<2ƂȂ悤ɒ
	while(NAcmp(XX,Cx10000)>= 0) {NFdiv(XX,XX, Cx10000); NFadd(L,L, HxLOG2);}
	while(NAcmp(XX,C2)     >= 0) {NFdiv(XX,XX, C2     ); NFadd(L,L, LOG2  );}
	while(NAcmp(XX,dCx)    <  0) {NFmlt(XX,XX, Cx10000); NFsub(L,L, HxLOG2);}
	while(NAcmp(XX,C1)     <  0) {NFmlt(XX,XX, C2     ); NFsub(L,L, LOG2  );}
	NFsub(XX,XX,C1); NFclear(A); // XX = XX - 1; A=0
	for(int i=N;i>0;i--){// x/(1 + x/(2 + x/(3 + 2x/(2 + 2x/(5 +c+ ix/(2 + ix/((2i+1) + c   
		NFloat ii, OP1;  NFintTo(ii, i); NFmlt(OP1, ii, XX);    // OP1 = i * XX
		NFloat OP2; NFintTo(OP2, 2 * i + 1); NFadd(OP2,OP2, A); // OP2 = (2*i+1)+A
		NFloat OP3; NFdiv(OP3,OP1, OP2); NFadd(OP3, C2,OP3);    // OP3 = 2+OP1/OP2
		NFdiv(A, OP1,OP3);											// A   = OP1/OP3
	}
	NFadd(A,C1,A); NFdiv(A,XX,A); NFadd(A,L,A);// A = L + XX / (1 + A);
}
int LogError(NFloat X){NFmmax(X); return 1; }	// log̃G[l

void NFpowMini(NFloat P, NFloat X, int N){				//  P = X^NiN͐, X>0j
	NFloat C1, XX; NFintTo(C1,1); NFcopy(P,C1);NFcopy(XX,X);
	for(int abN=abs(N);abN>0; abN>>=1, NAmlt(XX,XX,XX,false)) if(abN & 1) NAmlt(P,P,XX,true);
	if(N<0) NAdiv(P, C1,P); 
}
void NFhexaTo(NFloat X,char str[][5],int N){
	int DT;
	for(int i=2*N-2,j=0;i>=0;i-=2,j++)	{
		sscanf(str[j],"%4X",&DT);
		X[i]=DT& 0xFF;X[i+1]=DT >>8;
	}
}
void NFintTo(NFloat X,int DT[],int N){
	for(int i=2*N-2,j=0;i>=0;i-=2,j++)	{
		X[i]=DT[j]& 0xFF;X[i+1]=DT[j]>>8;
	}
}
void exp(NFloat R, NFloat X){							//  exp֐i}N[WJj
	//ȉ̕ύXNFLOATLEN=16̂Ƃ̂݁B
	//ύXƂNAPIERNAPIER2ɕύX邱ƁB
	int hexa[]={0x0001,0x2B7E,0x1516,0x28AE,0xD2A6,0xABF7,0x1588,0x09D0};
	NFloat NAPIER2;	NFintTo(NAPIER2,hexa,8);
	
	NFloat XX, K; NFcopy(XX,X); NFsetFlag(XX,false);	// ƂČvZ
	if(NFcmp(XX,MACHINE_EPS)<=0){NFintTo(R,1);return;}
	int KK=NFtoAbsInt(XX);NFintTo(K,KK); NFsub(XX,XX,K);// KK : 
	NFloat C1,E, AX, bE, NN, XbyN; NFintTo(C1,1);	// ̌vZ 
	NFcopy(E,C1); NFcopy(AX,C1);int N=1;
	do{		// exp(X) = 1 + X + X^2/2! + X^3/3! + X^4/4! +c
		NFcopy(bE,E); NFintTo(NN,N); NFdiv(XbyN,XX,NN);
		NFmlt(AX,AX,XbyN); NFadd(E,E,AX); N++;
	} while (NAcmp(bE,E)!=0);
	if(KK>0xB000) KK = 0xB000; // 0xB000𒴂ƃI[ot[({̓G[)
	//NFpowMini(XX,NAPIER,KK); NAmlt(R,E,XX);	// (̊^)~e^()
	NFpowMini(XX,NAPIER2,KK); NAmlt(R,E,XX);	// (̊^)~e^()
	if(NFgetFlag(X)) NAdiv(R,C1,R);				// X ̂ƂtɂB
}
void myExp(NFloat R, NFloat X){//  exp֐iAWJj
	//ȉ̕ύXNFLOATLEN=16̂Ƃ̂݁B
	//ύXƂNAPIERNAPIER2ɕύX邱ƁB
	//int hexa[]={0x0001,0x2B7E,0x1516,0x28AE,0xD2A6,0xABF7,0x1588,0x09D0};
	//NFloat NAPIER2;	NFintTo(NAPIER2,hexa,8);
	
	int N=2+4*(NFLOATLEN*50/16),i; 
	NFloat AbsX,KKnf,A,E,C2,C1,XX;NFintTo(C2,2);NFintTo(C1,1);
	NFabs(AbsX,X);int KK=NFtoAbsInt(X);
	NFintTo(KKnf,KK);NFsub(AbsX,AbsX,KKnf);
	NFmlt(A,AbsX,AbsX);NFintTo(E,0);i=N;
	do{
		NFloat IE;NFintTo(IE,i);NFadd(IE,IE,E);NFdiv(E,A,IE);i-=4;
	}while(i>2);
	NFloat B,D; NFsub(B,C2,AbsX);NFadd(B,E);NFmlt(D,C2,AbsX);NFdiv(D,D,B);
	NFadd(E,C1,D);	
	if(KK>0xB000) KK = 0xB000; // 0xB000𒴂ƃI[ot[({̓G[)
	//NFpowMini(XX,NAPIER2,KK); NAmlt(R,E,XX);	// (̊^)~e^()
	NFpowMini(XX,NAPIER,KK); NAmlt(R,E,XX);	// (̊^)~e^()
	if(NFgetFlag(X)) NAdiv(R,C1,R);				// X ̂ƂtɂB
}


void pow(NFloat Z, NFloat X, NFloat N){					//  Pow̌vZ
	NFloat LogX, nLogX;			// X^n = exp(n*log(X))p
	log(LogX, X); NFmlt(nLogX, LogX, N); exp(Z, nLogX);
}
void cosh(NFloat Z, NFloat X){
	NFloat Ex1, Ex2, C1,C2; NFintTo(C1,1);  NFintTo(C2,2);exp(Ex1, X);
	NFdiv(Ex2,C1,Ex1);NFadd(Z,Ex1,Ex2);NFdiv(Z,Z,C2);
}
void sinh(NFloat Z, NFloat X){
	NFloat Ex1, Ex2, C1,C2; NFintTo(C1,1);  NFintTo(C2,2);exp(Ex1, X);
	NFdiv(Ex2,C1,Ex1);NFsub(Z,Ex1,Ex2);NFdiv(Z,Z,C2);
}
void tanh(NFloat Z, NFloat X){
	NFloat Ex1, Ex2, C1,C2, XC, XS; NFintTo(C1,1);  NFintTo(C2,2);
	exp(Ex1, X); NFdiv(Ex2,C1,Ex1);NFadd(XC,Ex1,Ex2);NFsub(XS,Ex1,Ex2);
	NFdiv(Z,XS,XC);
}
#define NUMCXTB 8
void NFmachineE(NFloat X){// @B(Machine )vZ
	NFloat C1, CX[NUMCXTB],E, EN; NFintTo(C1,1); NFcopy(X,C1);
	NFintTo(CX[0],2); for(int i=1;i<NUMCXTB; i++) NAmlt(CX[i], CX[i-1],CX[i-1]);
	for(int i=NUMCXTB-1;i>=0;i--){
		NFcopy(E,X);
		do{	NFcopy(X,E);NAdiv(E,E, CX[i]); NAadd(EN,E,C1);
			//char Str[512];//**** ݂ƂA̒߂OB
			//NFtoExpStr(X,Str,10,true) ; printf("\n Machine (%d)  = %s," ,i,Str);
			//printf("\n Hexa ");NFprintHx(X);
		}while(NAcmp(EN,C1)>0);
	}
}

#define aCopy(X,Y) for(int i=0;i<NFLOATLEN; i++){ X[i]=Y[i];}
void NFmachineE2(NFloat X){// @B(Machine )vZ
	NFloat C1, E, C2, EN; NFintTo(C1,1);aCopy(E,C1);NFintTo(C2,2);//NFcopy(E,C1);int i;
	do{	
		aCopy(X,E);//NFcopy(X,E); 
		NAdiv(E,E, C2); NAadd(EN,E,C1);
		//char Str[512];//**** ݂ƂA̒߂OB
		//i++;
		//NFtoExpStr(E,Str,10,true) ; printf("\n Machine (%d)  = %s," ,i,Str);
		//printf("\n Hexa ");NFprintHx(X);
		
	}while(NAcmp(EN,C1)>0);
}

void paramGamma(NFloat A[]){   // K}֐vZpWݒ
	NFsetFrac(A[0], 0x0000, 0x15, 1, 0x55            );	//  A0 = 1/12
	NFsetFrac(A[1], 0x7FFF, 0x88, 1, 0x88            );	//  A1 = 1/30 
	NFsetFrac(A[2], 0x0000, 0x40, 3, 0x9C, 0x09, 0xC0);	//  A2 = 53/210
	NFloat X,Y;
	NFintTo(X,195)  ;NFintTo(Y,371)  ; NAdiv(A[3], X,Y);// A3 = 195/371
	NFintTo(X,22999);NFintTo(Y,22737); NAdiv(A[4], X,Y);// A4 = 22999/22737
	NFintTo(X,29944523);NFintTo(Y,19733142); 
	NAdiv(A[5], X,Y);							// A5 = 29944523/19733142
	NFstring(X,"1.09535241009"); NFstring(Y,"0.48264275462");
	NAdiv(A[6], X, Y);							// A6 = 109535241009/48264275462
}
void gamma(NFloat R, NFloat AX){// K}֐vZ(Aɂ)
	NFloat X, F, C1, L, LN; NFintTo(C1,1);
	NFintTo(L,4); NFcopy(X,AX);	NFcopy(F,C1);
	while(NFcmp(X,L)<0){
		NFmlt(F,F,X);
		NFadd(X,X,C1);
	}//ǨvZ
	
	NFloat A[7],Z; paramGamma(A);//AWJpp[^ݒ
	NFdiv(Z, A[6], X);//AWJ 
	for(int i=5;i>=0;i--){ NFadd(Z, X, Z); NFdiv(Z, A[i], Z); }
	//K}֐l߂
	log(LN, X); NFsub(LN,LN, C1);// LN= log(X)-1
	NFmlt(LN,X,LN),NFadd(Z,LN,Z); exp(Z,Z); //exp(X * (log(X)-1)*Z
	NFloat C2,Y;NFintTo(C2,2);
	NAmlt(Y,PAI,C2);NAdiv(Y, Y, X);sqrt(Y,Y);//sqrt(2/X)
	NFmlt(Y,Y,Z); NFdiv(R,Y,F);//sqrt(2/X)*exp(X * (log(X)-1)+Z)/F
}
void logGamma(NFloat R, NFloat AX){//  log((x))vZiAWJɂj
	NFloat X, F, C1, L, LN, LN2P; 
	NFintTo(C1,1); NFintTo(L,4); NFcopy(X,AX);NFclear(F); 
	while(NFcmp(X,L)<0){log(LN, X);NFsub(F, F, LN); NFadd(X,X,C1);}
	NFloat A[7],Z; paramGamma(A);//Ap萔ݒ
	NFdiv(Z, A[6], X); //AWJ
	for(int i=5;i>=0;i--){ NFadd(Z, X, Z); NFdiv(Z, A[i], Z); }
	NFloat C2,C0_5,X05; NFintTo(C2,2);NFstring(C0_5,"0.5");
	NFsub(X05,X, C0_5);log(LN, X);NFmlt(X05,X05,LN);// (X-0.5)*log(X)
	NAmlt(LN2P, PAI,C2); log(LN2P,LN2P);
	NAmlt(LN2P,LN2P,C0_5);// 0.5*log(2)
	NFadd(X05,X05, LN2P);
	NFsub(X05, X05, X);//(X-0.5)*log(X)+0.5*log(2)-X
	NFadd(X05,X05, Z);NFadd(R,X05,F); //(X-0.5)*log(X)+0.5*log(2)-X+Z+F
}
void startNFloat(){	// ΐAwAOp֐gOɕKĂяoƁB
	compPai(PAI) ;compNapier(NAPIER); log2(LOG2); NFmachineE(MACHINE_EPS);
}
#endif